<?php header("Cache-Control: no cache");
session_cache_limiter("private_no_expire"); ?> 
<?php
include_once("user/user.php");
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <title>Roku TV Boss</title>

    <!-- placeholders for the theme switcher -->
    <link rel='stylesheet' id='theme_stylesheet'>
    <link rel='stylesheet' id='icon_stylesheet'>

    <style>[class*="foundicon-"] {font-family: GeneralFoundicons;font-style: normal;}</style>
    <script src='dist/jsoneditor.min.js'></script>
	 <script src='dist/jquery-3.2.1.min.js'></script>
  
</head>
<body>
<?php include_once("user/header.php"); ?> 
<?php 
function getcurPageURL() {
 $pageURL = 'http';
 $pageURL .= "://";
 $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];

 return str_replace("/manage/","/feed/feed.json", $pageURL);
}

  if ((isset($_POST["password"]) && ($_POST["password"]=="$password")) && (isset($_POST["username"]) && ($_POST["username"]=="$username"))) {
?>
<div align='center'><a href='logout.php'>Logout</a></div>
<div style="width:80%; display: block; margin-left: auto; margin-right: auto;">
<div id='editor'></div>
</div>
<div class='container'>
    <div class='row'>
        
        <div class='span12 col-md-12 columns twelve large-12'>
            <h2>JSON</h2>
            <p>If you make direct modifications, update the form.
<button class='btn btn-primary' id='setvalue'>Update Form</button> When you're done, save the changes. <button class='btn btn-primary' id='savechanges'>Save Changes</button></p>
            <textarea id='output' style='width: 100%; height: 300px; font-family: monospace;' class='form-control'></textarea>


            <h2>JSON Feed URL</h2>
            <p>Below is the URL of your feed, to use when setting up your channel.
            <textarea id='feedurl' style='width: 100%; height: 40px; font-family: monospace;' class='form-control'><?php echo getcurPageURL(); ?></textarea>

            <div style="visibility:visible">
            <h2>TV Boss Validator</h2>
            <p>TV Boss Validator auto-updates whenever the form changes to show validation errors if there are any.</p>
            <textarea id='validate' style='width: 100%; height: 100px; font-family: monospace;' readonly disabled class='form-control'></textarea>
            </div>
        </div>               
        
        <div class='span12 col-md-12 columns twelve large-12'>
            <h2>JSONLint Validator</h2>
        	<p class="p">If you make any direct modifications and click on Update Form above, the form will NOT be updated if the code contains any errors. This is a safety mechanism built into TV Boss. If this happens, please check your feed with JSONLint Validator:</p>
            <ol>
              <li>Go to <a href="https://jsonlint.com/" target="_blank"><strong>JSONLint Validator</strong></a>, and</li>
              <li>Copy-and-paste the feed code above in the validator. and click on <strong>Validate JSON</strong>.</li>
            </ol>
        </div>
        
        <div class='row' style="visibility:hidden">
            <div class='span12 col-md-12 columns twelve large-12'>
                <h2>Schema</h2>
                <p>You can change the schema and see how the generated form looks.  After you make changes, click <button class='btn btn-primary' id='setschema'>Update Schema</button></p>

                <textarea id='schema' style='width: 100%; height: 450px; font-family: monospace;' class='form-control'></textarea>
            </div>
        </div>        
    </div>
                	
</div>
<script>
(function() {
    var schema = {
    "title": "Roku TV Channel Manager - Direct Publisher",
	"channel": "RokuTVChannel",  
	"type": "object",
	"properties": {    
		"providerName": {
			"type": "string",      
			"minLength": 3,
			"default": "C Point",
			"description": "The name of the channel provider"
		},
		"lastUpdated": {
			"type": "string",      
			"minLength": 25,
			"default": "2017-05-05T22:21:37+00:00"	
		},
		"language": {
			"type": "string",      
			"minLength": 2,
			"default": "en-US"
		},
		"shortFormVideos": {
			"type": "array",
			"format": "grid",
			"title": "shortFormVideos",
			"uniqueItems": true,
			"items": {
				"type": "object",				
				"title": "shortFormVideo",
				"properties": {
					"id": {
						"type": "string",      						
						"description": "Video ID"	
					},
					"title": {
						"type": "string",      
						"description": "Video Title"	
					},
					"shortDescription": {
						"type": "string",      
						"description": "Max 200 chars"
					},
					"tags": {
						"type": "array",
						"format": "table",						
						"uniqueItems": true,
						"items": {							
								"type": "string"      							
						}
					},					
					"content": {
						"type": "object",
						"properties": {
							"dateAdded": {
							"type": "string",      
							"description": "YYYY-MM-DDThh:mm:ss+TZ",
							"default": "2017-11-11T22:21:37+00:00"							
							},
							"duration": {
								"type": "integer",
								"description": "In seconds"
							},
        					"adBreaks": {
        						"type": "array",
        						"format": "table",						
        						"uniqueItems": true,
        						"items": {							
        								"type": "string", 
        								"description": "hh:mm:ss"
        					    }
        					},
							"trickPlayFiles": {
								"type": "array",
								"format": "table",
								"uniqueItems": false,
								"items": {
									"type": "object",
									"properties": {
										"quality": {
											"type": "string",
											"enum": [
												"HD",
												"FHD"
											],
											"default": "HD"
										},
										"url": {
											"type": "string",
											"description": "Trick Play URL"
										}
									}							
								}
							},							
						"videos": {
							"type": "array",
							"format": "table",
							"uniqueItems": false,
							"items": {
								"type": "object",
								"properties": {
									"url": {
										"type": "string",
										"description": "Video URL"
									},
									"quality": {
										"type": "string",
										"enum": [
										"HD",
										"FHD",
										"UHD"
										],
										"default": "HD"
									},
									"videoType": {
										"type": "string",
										"enum": [
										"HLS",
										"SMOOTH",
										"DASH",
										"MP4",
										"MOV",
										"M4V"											
										],
										"default": "MP4"
									},
									"bitrate": {
										"type": "integer",
										"description": "kbps"
									}										
								}										
								}
							}
						}
					},
					"genres": {
						"type": "array",
						"format": "table",
						"uniqueItems": true,
						"items": {							
								"type": "string",      							
								"enum": [
								"action",
								"adventure",
								"animals",
								"animated",
								"anime",
								"children",
								"comedy",
								"crime",
								"documentary",
								"drama",
								"educational",
								"fantasy",
								"faith",
								"food",
								"fashion",
								"gaming",
								"health",
								"history",
								"horror",
								"miniseries",
								"mystery",
								"nature",
								"news",
								"reality",
								"romance",
								"science",
								"science fiction",
								"sitcom",
								"special",
								"sports",
								"thriller",
								"technology"							
								],							
								"default": "action"															
						}
					},
					"thumbnail": {
						"type": "string",      
						"description": "800x450 thumb",
						"default": ""	
					},
					"releaseDate": {
						"type": "string",      
						"description": "YYYY-MM-DD",
						"default": "2017-05-18"	
					}
				  }
            			
		  }
		}				
	}
	
	}


    // Divs/textareas on the page
    var $schema = document.getElementById('schema');
    var $output = document.getElementById('output');
    var $editor = document.getElementById('editor');
    var $validate = document.getElementById('validate');

    // Buttons
    var $set_schema_button = document.getElementById('setschema');
    var $set_value_button = document.getElementById('setvalue');
	var $set_savechanges_button = document.getElementById('savechanges');

    var jsoneditor;

    var reload = function(keep_value) {
        var startval = (jsoneditor && keep_value)? jsoneditor.getValue() : window.startval;
        window.startval = undefined;

        if(jsoneditor) jsoneditor.destroy();
        jsoneditor = new JSONEditor($editor,{
            schema: schema,
            startval: startval
        });
        window.jsoneditor = jsoneditor;

        // When the value of the editor changes, update the JSON output and validation message
        jsoneditor.on('change',function() {
            var json = jsoneditor.getValue();

            $output.value = JSON.stringify(json,null,2);

            var validation_errors = jsoneditor.validate();
            // Show validation errors if there are any
            if(validation_errors.length) {
                $validate.value = JSON.stringify(validation_errors,null,2);
            }
            else {
                $validate.value = 'valid';
            }            
        });
    };

    // Start the schema and output textareas with initial values
    $schema.value = JSON.stringify(schema,null,2);
    $output.value = '';

    // When the 'update form' button is clicked, set the editor's value
    $set_value_button.addEventListener('click',function() {
        jsoneditor.setValue(JSON.parse($output.value));
    });

    // Save the contents when the button is clicked
    $set_savechanges_button.addEventListener('click',function() {
        try {
			thedata = $output.value;
			
			$.ajax({
				method: "POST",
				url: "savedata.php",
				data: {output: thedata},
				dataType: "json",
				success: function(result) {
                        alert('Data successfully saved!');
                    }
				})
				.done(function( msg ) {
			});
        }
        catch(e) {
            alert('Error: '+e.message);
            return;
        }
    });

    // Update the schema when the button is clicked
    $set_schema_button.addEventListener('click',function() {
        try {
            schema = JSON.parse($schema.value);
        }
        catch(e) {
            alert('Invalid Schema: '+e.message);
            return;
        }

        reload();
    });

    // Set the theme by loading the right stylesheets
    var setTheme = function(theme,no_reload) {
        theme = theme || '';

        var mapping = {
            barebones: '',
            html: '',
            bootstrap2: '//netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/css/bootstrap-combined.min.css',
            bootstrap3: '//netdna.bootstrapcdn.com/bootstrap/3.0.3/css/bootstrap.min.css',
            foundation3: '//cdnjs.cloudflare.com/ajax/libs/foundation/3.2.5/stylesheets/foundation.css',
            foundation4: '//cdn.jsdelivr.net/foundation/4.3.2/css/foundation.min.css',
            foundation5: '//cdn.jsdelivr.net/foundation/5.0.2/css/foundation.min.css',
            foundation6: '//cdn.jsdelivr.net/foundation/6.2.1/foundation.min.css',
            jqueryui: '//code.jquery.com/ui/1.10.3/themes/south-street/jquery-ui.css'
        };

        if(typeof mapping[theme] === 'undefined') {
            theme = 'bootstrap3';            
        }

        JSONEditor.defaults.options.theme = 'bootstrap3';

        document.getElementById('theme_stylesheet').href = mapping[theme];
        

        if(!no_reload) reload(true);
    };

    // Set the icontheme
    // Set the theme by loading the right stylesheets
    var setIconlib = function(iconlib,no_reload) {
        iconlib = iconlib || '';
        var mapping = {
            foundation2: '//cdnjs.cloudflare.com/ajax/libs/foundicons/2.0/stylesheets/general_foundicons.css',
            foundation3: '//cdnjs.cloudflare.com/ajax/libs/foundicons/3.0.0/foundation-icons.css',
            fontawesome3: '//cdnjs.cloudflare.com/ajax/libs/font-awesome/3.2.1/css/font-awesome.css',
            fontawesome4: '//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.0.3/css/font-awesome.css'
        };

        JSONEditor.defaults.options.iconlib = 'bootstrap3';

        document.getElementById('icon_stylesheet').href = mapping[iconlib] || '';

        if(!no_reload) reload(true);
    };



    setTheme((window.location.href.match(/[?&]theme=([^&]+)/)||[])[1] || 'bootstrap3', true);
    setIconlib((window.location.href.match(/[?&]iconlib=([^&]*)/)||[null,'fontawesome4'])[1], true);

	JSONEditor.defaults.options.object_layout = "grid";   
    JSONEditor.defaults.options.show_errors = 'always';
	JSONEditor.defaults.options['required_by_default'] = true;
	JSONEditor.defaults.options['display_required_only'] = false;
	JSONEditor.defaults.options['no_additional_properties'] = true;
	JSONEditor.defaults.options['ajax'] = true;
	JSONEditor.defaults.options['disable_edit_json'] = true;
	JSONEditor.defaults.options['disable_collapse'] = false;
	JSONEditor.defaults.options['collapsed'] = true;	
	JSONEditor.defaults.options['disable_properties'] = true;
	JSONEditor.defaults.options['disable_array_add'] = false;
	JSONEditor.defaults.options['disable_array_reorder'] = false;
	JSONEditor.defaults.options['disable_array_delete'] = false;
	JSONEditor.defaults.options['disable_array_delete_all_rows'] = false;
	JSONEditor.defaults.options['disable_array_delete_last_row'] = false;
	
    reload();
	loadthedata();
})();

function loadData(URL)
{
// Create the XML request  
	xmlReq = null;
	if(window.XMLHttpRequest) 		xmlReq = new XMLHttpRequest();
	else if(window.ActiveXObject) 	xmlReq = new ActiveXObject("Microsoft.XMLHTTP");
	if(xmlReq==null) return; // Failed to create the request

// Anonymous function to handle changed request states
	xmlReq.onreadystatechange = function()
	{
		switch(xmlReq.readyState)
		{
		case 0:	// Uninitialized
			break;
		case 1: // Loading
			break;
		case 2: // Loaded
			break;
		case 3: // Interactive
			break;
		case 4:	// Done!
			jsoneditor.setValue(JSON.parse(this.responseText));
			// txt = this.responseText;			
			break;
		default:
			break;
		}
	}

// Make the request
	xmlReq.open ('GET', URL, true);
	xmlReq.send (null);
}

function loadthedata()
{
	loadData("../feed/feed.json");	
}

</script>
<?php 
}
else
{
// Wrong password or no password entered display this message
if ((isset($_POST['password']) || $password == "") || (isset($_POST['username']) || $username == "")) {
  print "<p align=\"center\"><font color=\"red\"><strong>Incorrect Username of Password</strong></font></p>";}
  print "<form method=\"post\"><p align=\"center\">Enter the login information below:</p>";
  print "<p align=\"center\">Username: <input name=\"username\" size=\"25\" maxlength=\"10\">";
  print " Password: <input name=\"password\" type=\"password\" size=\"25\" maxlength=\"10\"> <input value=\"Login\" type=\"submit\"></p></form>";
}  
?>
<br>
<div align="center">Copyright &copy; <?php echo date('Y'); ?> 
<?php include_once("user/footer.php"); ?> 
</div>
<p class="p">&nbsp;</p> 
</body>
</html>
